/* Copyright 2006 Siva Dirisala */

public class NCR {

  public static void ncr(int n,int r,CombinationListener cl) {
    int[] combination = new int[r];
    ncrImpl(n,r,cl,combination,0,0);
  }

  private static boolean ncrImpl(int n,int r,CombinationListener cl,int[] combination,int i,int d) {
    if(d == r)
      return cl.combination(combination);
    else {
      for(int j=i+1;j<=n-r+1+d;j++) {
	combination[d] = j;
	if(!ncrImpl(n,r,cl,combination,j,d+1))
          return false;
      }
    }
    return true;
  }

  public static interface CombinationListener {
    public boolean combination(int[] combination);
  };

  static class DefaultCombinationListener implements CombinationListener {
    public boolean combination(int[] combination) {
      System.out.print(combination[0]);
      for(int i=1;i<combination.length;i++) {
        System.out.print(" ");
        System.out.print(combination[i]);
      }
      System.out.println();
      return true;
    }
  }

  public static void main(String[] args) {
    NCR.ncr(Integer.parseInt(args[0]),Integer.parseInt(args[1]),new DefaultCombinationListener());
  }
}
